# Next

- Add: install amadeus-rs as amadeus alongside lektord
- Add: add rust code to lektord -> common lib + new repo rs module
- Add: merge the amadeus-rs prokect into the lektor one
- Add: add file logging to lektord, the rotate operations are done by lektord to avoid running out of space if someone try to dos lektord...
- Add: Qt6 module for the player, it's the new default (will replace sdl2!)
- Add: hook to automatically upgrade the database scheme if needed
- Add: multi-add IDs, create a list with stb_ds and add its content in the queue, the adds are batched 10 per 10. When adding multiple times the same kara ID, it is only added once
- Add: dry-update command to only refresh the available kara in Kurisu and don't download them
- Add: the update command can take a query as an argument to only update parts of the database
- Add: restore the "install" operations. When typing `make install` or `ninja install` the binaries, scripts and manpages of lektor will be installed into the `CMAKE_INSTALL_PREFIX`
- Add: the folder permission is not settable at the creation of it, the value is modifiable in the config file at `database/dir_permission`
- Add: the regex used to populate the database from disk is now modifiable from the config file, the keys are `database/{types,categories,languages}`. Those fields must only contain alpha characters and commas
- Add: re-use more informations from databases when upgrading the database because minimal version where added to the different fields in the table descriptions
- Add: new field `repo_timestamp` which is the timestamp of the kara from the repo. This field is defaulted to the `cached_mtime` at upgrade time if needed
- Fix: fix incorrect parsing of lists of commands with multiple arguments: the parser could overrun the correct command buffer and insert a '\0' between the next command and its furst argument
- Fix: fix issue #100 -> the `database_queue_add_id` won't add ids that doesn't exist
- Fix: be explicit about truncated commands, when a command is truncated, all the bytes after the end of the new string and before the end of the old string are not set to '\0' for safety
- Fix: no segv on exit because disconnect client '0', no client '0', the first client is '1'
- Fix: can now interpret the *add* commands with spaces in the query correctly
- Fix: no more segv when copying a null URI
- Fix: previous command was not working when all the queue had the same priority
- Fix: when no screen is detected with `lkt`, the large screen behaviour is used to not break other commands like `wc`
- Fix: if a kara is not available it will be downloaded even if there is a file on the system (may be filtered out by a user specified URI)
- Fix: rely on CMake to find OpenMP support for a correct error reporting. OpenMP support is also marked in the README now
- Fix: no more SEGV when we don't find the module specified in the config file
- Fix: properly set LC_NUMERIC to C to avoid SEGV in mpv with module sdl2
- Change: get ride of MPV's deprecated symbols and use new way of doing things
- Change: now check the timestamp from kurisu and not the mtime from the disk when updating
- Change: not finding the module specified in a config file is now a fatal error, the error message has been improved
- Change: no longer set the locale, we only check if the local is an UTF-8 one and abort if it's not
- Change: all the functions in the command trie have the same signature (less bloat here)
- Change: the fields `database/{types,categories,languages}` must now only contain alpha characters and commas, nothing else!
- Change: reduce the number of regex creation in the populate database from disk part of the code
- Change: autotools to cmake toolchain
- Change: cmake minimal version to 3.17 because of policy CMP0100
- Change: the CI check if lektor compiles, no binary deployment for now
- Change: minimal version of Qt is now 6!
- Remove: delete `KLKT` as it is no longer maintained
- Remove: get ride of the SDL2 module

# v2.4 (752da467)

- Add: add luka, the new lktadm
- Add: add a clean way to close the server state
- Add: simple cache for kara duration and timestamp to read less from the disk/more at the same location
- Add: cache for valid/invalid mkv magic number (avoid always reading the disk)
- Add: cache for filename (avoid always reading the disk)
- Add: versions to database
- Add: row_format option for lkt, for small screens (can be oneline, pretty or auto)
- Fix: endiannes functions (again)
- Fix: fix the \_\_insert command
- Fix: linking on some platforms where the sqlite3_hard_heap_limit64 function is not present
- Fix: Malloc the correct struct and store it into the right pointer type...
- Fix: config detection when XDG_CONFIG_HOME is present in the ENV, we didn't update the conf path with it
- Fix: fix issue #97 -> lkt segfault with not found hostname
- Fix: fix issue #96 -> lektord segfault when passing one id with the `addid` MPD command
- Fix: fix issue #95 -> don't panic if arch is not here, don't segv when some options can't be set with MPV
- Change: now have macros to wrap malloc calls
- Change: now errors that are produced in the init phase of the sdl worker thread are reported and lektord should exit in a friendly manner
- Change: use the trie data structure to be more efficient at fetching the correct command from its name at handle time (listen.c)
- Change: enable LTO when detecting llvm compiler
- Change: Now check compiler version manually
- Change: worker and JSON parsing are now interruptible, it's not automagic tho
- Change: the 'update' and 'import' commands are now interruptible, they won't keep the lektord daemon alive after the 'kill' command
- Change: update manpages
- Change: install kagari with lektord, lkt, luka
- Change: all lektord threads are named if the OS permits it/is supported
- Change: update the window title depending on the play state/playing kara
- Change: disable scripts with libmpv
- Change: the 'touch kara' on update is done by the main thread to avoid race conditions with some new async operations done to always avoid burning the disk
- Remove: the 'static lib' option with liblektor is no longer available

# v2.3 (742699cc)

- Replace json-c by a custom json parser which parse only limited json
- Try to print the backtrace at SEGV
- Assert and abort will trigger a SEGV to try to display the backtrace
- Check if downloaded karas are matroska files (only the magic number)
- In case of restart get the klkt instance launched by the previous lektord
- The 'pause' command may take one argument to force the 'paused' state of lektord
- Add window icon
- Add the Klkt client (notification for desktops) to the lektor project
- Add AppImage builds for lektord, lkt and klkt
- Add basic controls to klkt (play, pause, next, previous, shuffle)
- Add SDL2-Image lib to the dependencies (--with-depends)
- Add klkt autolaunch option to config file
- Add the \_\_flat command to set all priorities to 1 in the queue
- Add MPD commands: seek, seekid, seekcur, delete (partial), playlistid
- Alias list\* commands as find
- lkt handle the playlistid (queue id) and \_\_flat (queue flatten), pause, unpause commands
- lkt `queue delete` is now `queue remove` to delete by id
- lkt `queue delete` now deletes a kara in the queue by their position
- lkt shuffle works the same way as klkt, it doens't force the 'play' command but unpause, i.e it doesn't replay the kara
- lkt shows the update progress
- Remove archlinux package support (replaced by AppImage)
- Fix dl process with the repo module
- Fix: the moveid was in fact a move command, no range supported
- Bug fix: reduce libs to link to lkt (dear autoconf...)
- Bug fix: fix #84, next and prev commands didn't worked correctly
- Bug fix: fix deadlock on next kara (the new aerobrin...)
- Bug fix: fixed move command

Revision 1 (04c4d50a)

- Package mkvpropedit inside the AppImage for it's no longer a dependency to the final binary
- Klkt is now distributed inside lektord's AppImage
- Add Kagari, a cli utility to use kurisu's API
- Fix deletion on the queue: adding new karas won't mess up all the queue
- Fix invalid insert in the database (#85)
- Fix 'SSL peer certificate or SSH remote key was not OK' on Fedora(#86)

# v2.2 (78143fa3)

- Download the bakabase with obfuscation or not
- Add json-c to the download dependency script (add cmake as a requirement for that)
- Choose between static or shared library for liblektor
- Download the bakabase with obfuscation or not
- Implicit types for queries with lkt
- Import favorites from kurisu as new playlists
- Catch signals to close cleanly lektord
- Don't echo stuff in the terminal while lektord is running (mostly done to have clean logs, even when pressing ^C)
- Prefix keys in the window with control, to avoid seeking with i3 when switching windows
- Deprecate the `VOCA` type
- Add time in logs
- Stop the playback when the last kara in the queue is terminated
- Add an option in the config file to not force the gpu context to X11
- Bug fix: can now start playing the last kara of the queue
- Bug fix: the deadlock on next kara should be fixed by not using the IDLE event from MPV
- Some other bug fixes...

# v2.1 (df74b85f)

- Add dependency dl system at configure time, to be able to build on systems that don't have the correct version of libraries
- Add hooks at queue begin and queue next events
- Some documentation update
- Auto create the config file when it doesn't exist
- Better separation of modules within lektor
- Bug fix: failed to clear
- Bug fix: incorrect play state with sdl2 module
- Bug fix: failed to insert, queue duplication

# v2.0 (02c1203b)

- Change build toolchain to autotools
- Asserts are enabled manually at runtime
- Enable static modules and debug builds at compile time
- Add a CI
- Update documentation
- Some refactor done
- Some bug fixes...

# v1.8 (3e1d569e)

- Command find <id> command
- Command lkt queue get renamed 'lkt queue database'
- Command lkt queue get is calling the find <id> command
- SDL shortcuts with control key
- Big and little endian support
- Modules are more modular
- Bug fixes

Revision 1 (1fc75ed9)

- Segfault correction when uri is an integer

Revision 2 (3fcf202e)

- Add plt list to list all available playlists
- Add plt list <name> [query] to list the content of a playlist with
  possibility of filtering the results with a query
- Fix some bugs (mostly segfaults on incorrect input)

Revision 3 (c41b723e)

- No more crash when inserting in the queue
- The lkt command is usable in php, some signal handlers can't be installed there (damn php)
- Some bug fixes

# v1.7 (1f2e80fa)

- DB lock
- SDL shortcuts
- DB improvements
- Restart keeps the play state
- Addid can add multiple ids to the queue
- Playlists and queue interaction improved
- Bug fixes...

# v1.6 (d7ac3759)

- Stickers support
- Update and rescan
- Archlinux package

# v1.5 (70c68ec6)

- Bug fixes
- Drop search add and search insert, use queue add and queue insert now
- Own ini parser
- Source code is only in ISC licence

# v1.4 (f0615d2f)

- Sync from kurisu with update and rescan commands
- Manpages
- Introduction of mthread
- Compiles with gcc and clang

# v1.3 (89c82c01)

- Drop PCRE dependency
- Add help to lkt and lktadm commands

# v1.2 (5974e1ba)

- Add the sdl module
